PKEY(1) | OpenSSL | PKEY(1)

# NAME

pkey - public or private key processing tool

# LIBRARY

libcrypto, -lcrypto

# SYNOPSIS

openssl pkey [ -inform PEM|DER] [ -outform PEM|DER] [ -in filename] [ -passin arg] [ -out filename] [ -passout arg] [ -cipher] [ -text] [ -text_pub] [ -noout] [ -pubin] [ -pubout] [ -engine id]

# DESCRIPTION

The pkey command processes public or private keys. They can be converted between various forms and their components printed out.

# COMMAND OPTIONS

-inform DER|PEM
  This specifies the input format DER or PEM.

-outform DER|PEM
  This specifies the output format, the options have the same meaning as the -inform option.

-in filename
  This specifies the input filename to read a key from or standard input if this option is not specified. If the key is encrypted a pass phrase will be prompted for.

-passin arg
  the input file password source. For more information about the format of arg see the PASS PHRASE ARGUMENTS section in openssl(1).

-out filename
  This specifies the output filename to write a key to or standard output if this option is not specified. If any encryption options are set then a pass phrase will be prompted for. The output filename should not be the same as the input filename.

-passout password
  the output file password source. For more information about the format of arg see the PASS PHRASE ARGUMENTS section in openssl(1).

-cipher
  These options encrypt the private key with the supplied cipher. Any algorithm name accepted by EVP_get_cipherbyname() is acceptable such as des3.

-text
  prints out the various public or private key components in plain text in addition to the encoded version.

-text_pub
  print out only public key components even if a private key is being processed.

-noout
  do not output the encoded version of the key.

-pubin
  by default a private key is read from the input file: with this option a public key is read instead.

-pubout
  by default a private key is output: with this option a public key will be output instead. This option is automatically set if the input is a public key.

-engine id
  specifying an engine (by its unique id string) will cause pkey to attempt to obtain a functional reference to the specified engine, thus initialising it if needed. The engine will then be set as the default for all available algorithms.

# EXAMPLES

To remove the pass phrase on an RSA private key:

     openssl pkey -in key.pem -out keyout.pem

To encrypt a private key using triple DES:

     openssl pkey -in key.pem -des3 -out keyout.pem

To convert a private key from PEM to DER format:

     openssl pkey -in key.pem -outform DER -out keyout.der

To print out the components of a private key to standard output:

     openssl pkey -in key.pem -text -noout

To print out the public components of a private key to standard output:

     openssl pkey -in key.pem -text_pub -noout

To just output the public part of a private key:

     openssl pkey -in key.pem -pubout -out pubkey.pem

# SEE ALSO

genpkey(1), openssl_rsa(1), openssl_pkcs8(1), openssl_dsa(1), openssl_genrsa(1), openssl_gendsa(1)

2009-07-19 | 1.0.2k